#include "event_system.h"
#include <stdio.h>

#define ARR_LEN(ARR) (sizeof(ARR) / sizeof(ARR[0]))

void callback(void *data);
void callback1(void *data);
void callback2(void *data);
void callback3(void *data);
void callback4(void *data);
void callback5(void *data);

int main(void) {
  EventSystem es = es_init(16, 64);

  for (int i = 0; i < 40; ++i) {
    Event ev = es_register_event(es);
    printf("%lu\n", ev.id);
  }

  printf("\n");

  unsigned int count = 6;

  for (int i = 0; i < count; ++i) {
    es_deregister_event(es, (Event){ .id = (i + 1) * 2 });
  }

  for (int i = 0; i < count; ++i) {
    Event ev = es_register_event(es);
    printf("%lu\n", ev.id);
  }

  printf("\n");

  es_deregister_event(es, (Event){ .id = 10 });
  Event ev = es_register_event(es);
  for (int i = 0; i < 10; ++i) {
    EventListener listener = es_add_event_listener(es, ev, callback);
    printf("Event: %lu, ID: %lu\n", listener.event.id, listener.id);
  }

  printf("\n");

  for (int i = 5; i < 8; ++i) {
    es_remove_event_listener(es, (EventListener){ .event = ev, .id = i });
  }

  for (int i = 0; i < 3; ++i) {
    EventListener listener = es_add_event_listener(es, ev, callback);
    printf("Event: %lu, ID: %lu\n", listener.event.id, listener.id);
  }

  printf("\n");

  EventCallback callbacks[] = {callback1, callback2, callback3, callback4, callback5};
  EventListener listeners[ARR_LEN(callbacks)] = {0};
  Event ev_with_callbacks = (Event){ .id = 20 };
  for (int i = 0; i < ARR_LEN(callbacks); ++i) {
    listeners[i] = es_add_event_listener(es, ev_with_callbacks, callbacks[i]);
  }

  es_emit_event(es, ev_with_callbacks, (void *)0);

  printf("\n");

  es_remove_event_listener(es, listeners[2]);

  es_emit_event(es, ev_with_callbacks, (void *)0);

  printf("\n");

  printf("SYSTEM: %lu\n", es.id);
  es_deinit(&es);
  printf("SYSTEM: %lu\n", es.id);

  return 0;
}

void callback(void *data) {
  return;
}

void callback1(void *data) {
  printf("Hello from callback1\n");
}

void callback2(void *data) {
  printf("Hello from callback2\n");
}

void callback3(void *data) {
  printf("Hello from callback3\n");
}

void callback4(void *data) {
  printf("Hello from callback4\n");
}

void callback5(void *data) {
  printf("Hello from callback5\n");
}
